# $Revision: 1.49 $, $Date: 2009/04/06 15:08:40 $
#
# Conditional build:
%bcond_without	initrd		# without initrd version
%bcond_without	dietlibc	# build initrd version with static glibc instead of dietlibc
%bcond_without	selinux		# build without SELinux support (needs selinux-disabled device-mapper)
#
Summary:	Device-mapper RAID tool
Summary(pl.UTF-8):	Narzędzie do RAID-u opartego o device-mapper
Name:		dmraid
Version:	1.0.0
%define	_rc	rc15
Release:	0.%{_rc}.5
License:	GPL
Group:		Base
Source0:	http://people.redhat.com/~heinzm/sw/dmraid/src/%{name}-%{version}.%{_rc}.tar.bz2
# Source0-md5:	2602887205a35f89b59eeba3a868150f
Source1:	%{name}-initramfs-hook
Source2:	%{name}-initramfs-local-top
Patch0:		%{name}-selinux-static.patch
Patch1:		%{name}-fix.patch
Patch2:		%{name}-optflags.patch
Patch3:		%{name}-as-needed.patch
Patch4:		%{name}-unsigned.patch
Patch5:		%{name}-diet.patch
URL:		http://people.redhat.com/~heinzm/sw/dmraid/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	device-mapper-devel >= 1.02.02
BuildRequires:	zlib-devel
%if %{with initrd}
	%if %{with dietlibc}
BuildRequires:	device-mapper-dietlibc
BuildRequires:	dietlibc-static >= 2:0.31-5
	%else
BuildRequires:	device-mapper-static >= 1.02.05-0.4
BuildRequires:	glibc-static
%if %{with selinux}
BuildRequires:	libselinux-static
BuildRequires:	libsepol-static
%endif
	%endif
%endif
%if %{with selinux}
BuildRequires:	libselinux-devel
BuildRequires:	libsepol-devel
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir	/sbin

%description
DMRAID supports device discovery, set activation and display of
properties for ATARAID on Linux >= 2.4 using device-mapper.

%description -l pl.UTF-8
DMRAID obsługuje wykrywanie urządzeń, ustawianie aktywacji i
wyświetlanie właściwości ATARAID-u na Linuksie >= 2.4 przy użyciu
device-mappera.

%package devel
Summary:	Header files for dmraid library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki dmraid
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
dmraid-devel provides a library interface for RAID device discovery,
RAID set activation and display of properties for ATARAID volumes.

%description devel -l pl.UTF-8
Ten pakiet udostępnia interfejs biblioteczny do wykrywania urządzeń
RAID, włączania zestawu RAID i wyświetlania właściwości wolumenów
ATARAID.

%package static
Summary:	Static library for dmraid
Summary(pl.UTF-8):	Statyczna biblioteka dmraid
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
dmraid-static provides a library interface for RAID device discovery,
RAID set activation and display of properties for ATARAID volumes.

%description static -l pl.UTF-8
Ten pakiet udostępnia statyczną bibliotekę do wykrywania urządzeń
RAID, włączania zestawu RAID i wyświetlania właściwości wolumenów
ATARAID.

%package initrd
Summary:	Device-mapper RAID tool - statically linked version
Summary(pl.UTF-8):	Narzędzie do RAID-u opartego o device-mapper - wersja statyczna
Group:		Base
Conflicts:	geninitrd < 10000.10

%description initrd
Statically linked version of dmraid utility.

%description initrd -l pl.UTF-8
Statycznie skonsolidowana wersja programu narzędziowego dmraid.

%package initramfs
Summary:	Device-mapper RAID tool - support scripts for initramfs-tools
Summary(pl.UTF-8):	Narzędzie do RAID-u opartego o device-mapper - skrypty dla initramfs-tools
Group:		Base
Requires:	%{name} = %{version}-%{release}
Requires:	initramfs-tools

%description initramfs
Device-mapper RAID tool - support scripts for initramfs-tools.

%description initramfs -l pl.UTF-8
Narzędzie do RAID-u opartego o device-mapper - skrypty dla initramfs-tools.

%prep
%setup -q -n %{name}
mv */* ./
%{?with_selinux:%patch0 -p2}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build
cp -f /usr/share/automake/config.sub autoconf
%{__aclocal}
%{__autoconf}

%if %{with initrd}
%configure \
	%if %{with dietlibc}
	CC="diet %{__cc} %{rpmcflags} %{rpmldflags} -Os -static" \
	--disable-libselinux \
	--disable-libsepol \
	%else
		%if %{with selinux}
	--enable-libselinux \
	--enable-libsepol \
		%endif
	%endif
	--enable-static_link

%{__make} -j1
mv -f tools/dmraid dmraid-initrd
%{__make} clean
%endif

%configure \
	--enable-shared_lib
%{__make} -j1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/%{_lib},%{_datadir}/initramfs-tools/{hooks,scripts/local-top}}

%{__make} install \
	includedir=$RPM_BUILD_ROOT%{_includedir} \
	libdir=$RPM_BUILD_ROOT%{_libdir} \
	mandir=$RPM_BUILD_ROOT%{_mandir} \
	sbindir=$RPM_BUILD_ROOT%{_sbindir}

mv $RPM_BUILD_ROOT%{_libdir}/libdmraid.so.* $RPM_BUILD_ROOT/%{_lib}
ln -sf /%{_lib}/$(cd $RPM_BUILD_ROOT/%{_lib} ; echo libdmraid.so.*.*.*) \
        $RPM_BUILD_ROOT%{_libdir}/libdmraid.so

%if %{with initrd}
install -d $RPM_BUILD_ROOT%{_libdir}/initrd
install dmraid-initrd $RPM_BUILD_ROOT%{_libdir}/initrd/dmraid
%endif

install %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/initramfs-tools/hooks/dmraid
install %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/initramfs-tools/scripts/local-top/dmraid

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc README TODO doc/dmraid_design.txt
%attr(755,root,root) %{_sbindir}/dmraid
%attr(755,root,root) /%{_lib}/libdmraid.so.*.*.*
%{_mandir}/man8/*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libdmraid.so
%{_includedir}/dmraid

%files static
%defattr(644,root,root,755)
%{_libdir}/libdmraid.a

%if %{with initrd}
%files initrd
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/initrd/dmraid
%endif

%files initramfs
%defattr(644,root,root,755)
%attr(755,root,root) %{_datadir}/initramfs-tools/hooks/dmraid
%attr(755,root,root) %{_datadir}/initramfs-tools/scripts/local-top/dmraid

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: dmraid.spec,v $
Revision 1.49  2009/04/06 15:08:40  baggins
- rel 5
- proper C on geninitrd

Revision 1.48  2009/03/23 14:10:51  baggins
- unify dietlibc compile options and calls

Revision 1.47  2009/03/23 13:03:13  baggins
- Conflicts: geninitrd <= 10000.3 (geninitrd-10000.3 doesn't know _libdir/initrd)

Revision 1.46  2009/03/23 12:59:05  baggins
- put programs for initrd into common directory _libdir/initrd

Revision 1.45  2009/03/18 23:20:14  baggins
- fix static link (selinux_static patch)
- clean bconds
- fix 64bit diet build

Revision 1.44  2009/03/18 23:10:54  baggins
- fix bcond

Revision 1.43  2009/03/18 14:13:51  baggins
- rel 4
- added unsigned patch (uint -> unsigned int, die, BSD, die!)
- build with dietlibc by default
- no selinux in dietlibc-based initrd binary

Revision 1.42  2009/02/27 21:08:55  baggins
- rel 3
- moved dmraid binary and library to /

Revision 1.41  2009/02/26 15:20:38  baggins
- rel 2

Revision 1.40  2009/02/26 15:12:45  baggins
- added initramfs subpackage (NEED TESTERS)

Revision 1.39  2009/02/26 14:32:57  baggins
- added initramfs support files to package

Revision 1.38  2008/09/27 23:07:58  charles
- up to rc15

Revision 1.37  2007/05/31 12:23:45  areq
- 1.0.0-0.rc14

Revision 1.36  2007/02/14 16:24:48  qboosh
- updated as-needed patch, BR: zlib-devel (for crc32() used for ddf format)

Revision 1.35  2007/02/12 21:23:53  glen
- tabs in preamble

Revision 1.34  2007/02/12 00:48:46  baggins
- converted to UTF-8

Revision 1.33  2007/02/04 12:02:18  qboosh
- tab; selinux bcond setting must be the same as device-mapper's

Revision 1.32  2007/02/03 16:20:14  areq
- dmraid-1.0.0.rc13
- bcond_without  selinux

Revision 1.31  2006/10/05 21:33:57  qboosh
- updated to 1.0.0.rc11

Revision 1.30  2006/09/06 12:01:17  sparky
- -j1, build was broken on smp

Revision 1.29  2006/07/30 23:23:12  sparky
- added as-needed patch

Revision 1.28  2006/05/22 22:44:22  qboosh
- rel 1.6

Revision 1.27  2006/05/22 22:43:12  qboosh
- -devel R: base now

Revision 1.26  2006/05/22 22:42:30  qboosh
- added fix,optflags patches, build shared library

Revision 1.25  2006/05/18 20:07:01  glen
- build with -fPIC on x86_64/amd64

Revision 1.24  2006/05/18 17:18:01  qboosh
- pl for -devel,-static

Revision 1.23  2006/05/16 20:50:10  glen
- created -devel and -static

Revision 1.22  2006/05/16 19:39:24  glen
- current libselinux (Ac: 1.28-2) has symbols from libsepol, adjust BR for initrd

Revision 1.21  2006/03/26 22:18:52  qboosh
- updated to 1.0.0.rc10

Revision 1.20  2006/02/26 18:35:13  sparky
- pass CC and CFLAGS

Revision 1.19  2005/10/17 19:23:16  qboosh
- removed obsolete bigendian-fix patch

Revision 1.18  2005/10/13 16:07:45  glen
- rel 1

Revision 1.17  2005/10/13 08:56:27  glen
- rc9

Revision 1.16  2005/05/03 15:20:35  arekm
- BR new dm

Revision 1.15  2005/04/17 17:19:34  darekr
- killed BR gettext-devel

Revision 1.14  2005/04/17 12:42:01  paszczus
- adapratized

Revision 1.13  2005/04/17 12:36:51  paszczus
- updated to 1.0.0rc7
- updated dmraid-selinux-static.patch

Revision 1.12  2005/04/17 12:18:12  sparky
- kill gettextize, package isn't using it and it fails with new gettext
- fixed build without initrd
- fixed build on big endian arch

Revision 1.11  2005/04/06 19:50:32  paszczus
- updated to 1.0.0rc6

Revision 1.10  2005/02/23 17:51:48  adasi
- added missing BR's

Revision 1.9  2005/02/21 20:14:35  ankry
- no pl jargon please

Revision 1.8  2005/02/21 19:45:59  qboosh
- initrd bcond, cosmetics

Revision 1.7  2005/02/21 18:45:06  adasi
- added static version
- still needs fix - won't work on non-selinux systems
- static version not tested
- anyone wants to include it in geninitrd? :)

Revision 1.6  2004/11/25 22:59:07  areq
- dmraid 1.0.0-rc5f

Revision 1.5  2004/11/03 22:23:33  ankry
- rel. .2

Revision 1.4  2004/11/03 22:02:06  ankry
- attempt to fix on amd64

Revision 1.3  2004/11/03 21:42:17  adasi
- proper release

Revision 1.2  2004/09/08 17:53:16  qboosh
- pl, BR: am,gt

Revision 1.1  2004/09/07 15:10:36  areq
- init PLD spec
